-- game mode settings

freeslot("TOL_PROPHUNT")

G_AddGametype({
	name = "Prop hunt",
	identifier = "prophunt",
	typeoflevel = TOL_PROPHUNT,
	rules = GTR_RINGSLINGER|GTR_SPECTATORS|GTR_TEAMS|GTR_BLINDFOLDED|GTR_NOSPECTATORSPAWN|GTR_HURTMESSAGES|GTR_TIMELIMIT,
	intermissiontype = int_teammatch,
	headerleftcolor = 152,
	headerrightcolor = 128,
	description = 'In this mode Blue team takes job is to disguise themselves as other props scattered around the map while the Red team finds and destroys them before their time or rings run out!'
})

-- establish prop object
freeslot("MT_PROP", "MT_HITBOX", "MT_TAUNT", "S_PROP")

mobjinfo[MT_PROP] = {
	doomednum = -1,
	spawnstate = S_PROP,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SPECIAL|MF2_DONTDRAW,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT
}

mobjinfo[MT_HITBOX] = {
	doomednum = -1,
	spawnstate = S_PROP,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SHOOTABLE|MF2_DONTDRAW,
	radius = 16*FRACUNIT,
	height = 40*FRACUNIT
}
mobjinfo[MT_TAUNT] = {
	doomednum = -1,
	spawnstate = S_PROP,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SHOOTABLE|MF2_DONTDRAW,
	radius = FRACUNIT,
	height = FRACUNIT
}
states[S_PROP] = {SPR_RING,0}

-- =- our variables -=
-- player skins
local huntskins = {{"Mario",SPR_MARI,"MARIC2C8",
0,0,0,
0,0,0,
0,3,TICRATE/4,
0,3,TICRATE/2,
4,4,0,
5,5,0,
3,3,0,
6,6,0,
7,7,0},
{"DOOM guy",SPR_DMGY,"DMGYA2A8",
0,0,0,
0,0,0,
0,3,TICRATE/4,
0,3,TICRATE/2,
0,0,0,
3,3,0,
4,5,TICRATE/2,
6,6,0,
6,6,0}}

-- intro messages

local huntmessages = {"Find the fakers!","Go get em'","Break the props!","M O R T I S","Welcome to my school house"}
local propmessages = {"The hunters are here!","MARIO has logged in!","you better watch out","Boo!","A wind blows through you...","M O R T I S","Quick, log out!","Big Apple 3AM"}


-- list of uncopyables
-- flags
local pdontcop = {MF_ENEMY, MF_SPECIAL, MF_NOSECTOR, MF_MISSILE, MF_PAIN, MF_BOSS}--, MT_BUBBLES, MT_SMALLBUBBLE, MT_MEDIUMBUBBLE, MT_EXTRALARGEBUBBLE}
-- props
local pthinddontcop = {MT_BUBBLES, MT_SMALLBUBBLE, MT_MEDIUMBUBBLE, MT_EXTRALARGEBUBBLE, MT_DUSTDEVIL, MT_MINECART, MT_MINECARTSEG, MT_MINECARTSPAWNER, MT_SALOONDOOR, MT_SALOONDOORCENTER, MT_TRAINCAMEOSPAWNER, MT_BIG_PALMTREE_TRUNK, MT_BIG_PALMTREE_TOP, MT_PALMTREE_TRUNK, MT_PALMTREE_TOP, MT_BOOSTERSEG, MT_BOOSTERROLLER, MT_YELLOWBOOSTER, MT_REDBOOSTER}
-- list of damagers
local pcanhurt = {MT_REDRING, MT_THROWNBOUNCE, MT_THROWNINFINITY, MT_THROWNAUTOMATIC, MT_THROWNSCATTER, MT_THROWNEXPLOSION, MT_THROWNGRENADE}

-- used to determine if prop can be copied at level start
local isprop = true

local awaycam

-- player count
local propcount = 0
local huntcount = 0

local teamWin = 0
local winTime = 7
local winWait = winTime*TICRATE

-- server message
local propmessage = {"", ""}
local propmestime = 0
local extendedtime = 10

-- server settings 

-- start the match
local startmatch = true

-- wait time initializer (can be set with a console command)
local waitinit = 30*TICRATE
-- wait time (default 30 seconds)
local waittime = waitinit

local defaultmatchtime = 300*TICRATE
local matchtime = defaultmatchtime

-- hide and seek mode (can't move after countdown)
local hideseek = false

-- default health
--local defaulthealth = 6
local defaultrings = 10
local ringlist = {}

--== free slots ==--
freeslot("sfx_s2cryl","sfx_sebell",
-- Sonic
"sfx_DSSHEY","sfx_DSSITSNOUSE","sfx_DSSLOW","sfx_DSSNOTHING","sfx_DSSOIL","sfx_DSSPRES","sfx_DSSRAT","sfx_DSSSAVE","sfx_DSSSAYON","sfx_DSSSCREAM","sfx_DSSTERIA","sfx_DSSWHAT","sfx_DSSWHO","sfx_DSSYEAH","sfx_DSSBLOW","sfx_DSSCOME","sfx_DSSDARK","sfx_DSSFAKE","sfx_DSSFOUND","sfx_DSSHERE",
-- Tails
"sfx_DSTTRAINS","sfx_DSTWHAT","sfx_DSTALT","sfx_DSTGET","sfx_DSTHOW","sfx_DSTJAM","sfx_DSTKNUX","sfx_DSTNOW","sfx_DSTSCREAM","sfx_DSTTADA",
-- Knucks
"sfx_DSKSHOT","sfx_DSKWHAT","sfx_DSKYOU","sfx_DSKOHNO",
-- egg
"sfx_DSEPHONE","sfx_DSEAGH","sfx_DSESILENCE","sfx_DSEAHA","sfx_DSEKEEP","sfx_DSELAUGH","sfx_DSELOAD","sfx_DSENOWAY",
-- amy
"sfx_DSADONT","sfx_DSAPAY","sfx_DSAPITY","sfx_DSASLEP","sfx_DSABORED",
-- shadow
"sfx_DSSHVENG","sfx_DSSHWHAT","sfx_DSSHAPOC","sfx_DSSHFAKE","sfx_DSSHINTER","sfx_DSSHKART","sfx_DSSHPATH","sfx_DSSHSTART",
-- sonics school house
"sfx_DSWANSWER","sfx_DSANSWER","sfx_DSBABY","sfx_DSBUZZP","sfx_DSDONTDO","sfx_DSELHIT","sfx_DSFUN","sfx_DSLEAVING","sfx_DSLIKE","sfx_DSMATH","sfx_DSRECYCLE","sfx_DSSADVEN","sfx_DSSCHOOL","sfx_DSSCHWHAT","sfx_DSSMART",
-- mario
"sfx_DSMGIB","sfx_DSMHAHA","sfx_DSMHELLO","sfx_DSMHERE","sfx_DSMITME","sfx_DSMLETGO","sfx_DSMMAMA","sfx_DSMOKLI","sfx_DSMSCREAM","sfx_DSMWOAH","sfx_DSMWOHAHO","sfx_DSMYAHO","sfx_DSMYIPE","sfx_DSMBOWSER","sfx_DSMCOUGH","sfx_DSMDOH","sfx_DSMFIRE",
-- half life
"sfx_DSHIHEAR","sfx_DSHLISTEN","sfx_DSHMORE","sfx_DSHSCARED","sfx_DSHSERIOUS","sfx_DSHTIE","sfx_DSHWAY","sfx_DSHADMIN","sfx_DSHAH","sfx_DSHANOTH","sfx_DSHCOUGH","sfx_DSHCRAZY","sfx_DSHDIE","sfx_DSHFOOL","sfx_DSHHEAD","sfx_DSHHER","sfx_DSHHE2","sfx_DSHHEEY","sfx_DSHHELLO",
-- hit sounds
-- sonics
"sfx_DSSOUCH","sfx_DSSOOPHS",
-- egg
"sfx_DSEAGH",
-- mario
"sfx_DSMPAIN","sfx_DSMOOF",
-- hl
"sfx_hp1","sfx_hp2","sfx_hp3","sfx_hp4","sfx_hp5")

-- captions
sfxinfo[sfx_s2cryl] = { caption = "Hill top whistle" }
sfxinfo[sfx_sebell] = { caption = "Bell" }

-- Sonic captions
sfxinfo[sfx_dsshey] = { caption = "Hey Hey Hey" }
sfxinfo[sfx_dssits] = { caption = "It's no use" }
sfxinfo[sfx_dsslow] = { caption = "Talk about low budget flights, no food or movie? I'm out of here" }
sfxinfo[sfx_dssnot] = { caption = "Nothing's happening" }
sfxinfo[sfx_dssoil] = { caption = "I smell oil" }
sfxinfo[sfx_dsspre] = { caption = "Tails, did you find the president?" }
sfxinfo[sfx_dssrat] = { caption = "This makes me feel like a rat" }
sfxinfo[sfx_dsssav] = { caption = "You actually saved me you know" }
sfxinfo[sfx_dsssay] = { caption = "Sayonara Shadow the hedgehog" }
sfxinfo[sfx_dssscr] = { caption = "WAAAAAAAAAAAAAAAAAAAOOOOOOAAH" }
sfxinfo[sfx_dsster] = { caption = "TERIA" }
sfxinfo[sfx_dsswha] = { caption = "What do you think you're doing?" }
sfxinfo[sfx_dsswho] = { caption = "Do you know who I am?" }
sfxinfo[sfx_dssyea] = { caption = "Yeah" }
sfxinfo[sfx_dssblo] = { caption = "BLOWS UP!?" }
sfxinfo[sfx_dsscom] = { caption = "Hey wait... Someone is coming" }
sfxinfo[sfx_dssdar] = { caption = "Better not let the dark side win" }
sfxinfo[sfx_dssfak] = { caption = "Say something you fake hedgehog" }
sfxinfo[sfx_dssfou] = { caption = "I found you, faker" }
sfxinfo[sfx_dssher] = { caption = "Here I go" }
-- tails
sfxinfo[sfx_dsttra] = { caption = "Trains are cool too" }
sfxinfo[sfx_dstwha] = { caption = "That's eggman, I wonder what happened to Sonic?" }
sfxinfo[sfx_dstalt] = { caption = "Hey the ship is losing altitude" }
sfxinfo[sfx_dstget] = { caption = "Hey we can't let him get away" }
sfxinfo[sfx_dsthow] = { caption = "How's it going guys?" }
sfxinfo[sfx_dstjam] = { caption = "Time to jam" }
sfxinfo[sfx_dstknu] = { caption = "Hey Knuckles, what's up?" }
sfxinfo[sfx_dstnow] = { caption = "Now what do we do?" }
sfxinfo[sfx_dstscr] = { caption = "WAAAAAAAAAH" }
sfxinfo[sfx_dsttad] = { caption = "Tadah!" }
-- knuckles
sfxinfo[sfx_dsksho] = { caption = "Give it your best shot!" }
sfxinfo[sfx_dskwha] = { caption = "What's going on here?" }
sfxinfo[sfx_dskyou] = { caption = "Me? what about you!?" }
sfxinfo[sfx_dskohn] = { caption = "oh no" }
-- egg
sfxinfo[sfx_dsepho] = { caption = "I'm taking everything from you, give me your phone" }
sfxinfo[sfx_dseagh] = { caption = "Agh" }
sfxinfo[sfx_dsesil] = { caption = "Silence" }
sfxinfo[sfx_dseaha] = { caption = "HAH HAH" }
sfxinfo[sfx_dsekee] = { caption = "You think you can keep up with me?" }
sfxinfo[sfx_dselau] = { caption = "HA HA HA HA HA HA HA HA" }
sfxinfo[sfx_dseloa] = { caption = "Get a load of this!" }
sfxinfo[sfx_dsenow] = { caption = "No way, I can't believe this!" }
-- amy
sfxinfo[sfx_dsadon] = { caption = "I don't like places like this" }
sfxinfo[sfx_dsapay] = { caption = "You're going to pay for what you've done" }
sfxinfo[sfx_dsapit] = { caption = "I pity you" }
sfxinfo[sfx_dsasle] = { caption = "yawn, I'm getting sleepy" }
sfxinfo[sfx_dsabor] = { caption = "Gee I'm bored" }
-- shadow
sfxinfo[sfx_dsshve] = { caption = "Vengence" }
sfxinfo[sfx_dsshwh] = { caption = "What" }
sfxinfo[sfx_dsshap] = { caption = "Apocolypse" }
sfxinfo[sfx_dsshfa] = { caption = "Faker? I think you're the fake hedgehog around here" }
sfxinfo[sfx_dsshin] = { caption = "I'm not interested" }
sfxinfo[sfx_dsshka] = { caption = "Kart racing" }
sfxinfo[sfx_dsshpa] = { caption = "You are one pathetic creature" }
sfxinfo[sfx_dsshst] = { caption = "It all starts with this" }
-- Sonics school house
sfxinfo[sfx_dswans] = { caption = "That's not the answer, try again" }
sfxinfo[sfx_dsansw] = { caption = "That's not the answer you want" }
sfxinfo[sfx_dsbaby] = { caption = "Baby" }
sfxinfo[sfx_dsbuzz] = { caption = "You don't have the buzz pass yet, give it anotehr try" }
sfxinfo[sfx_dsdont] = { caption = "Don't do that" }
sfxinfo[sfx_dselhi] = { caption = "Elephant hit" }
sfxinfo[sfx_dsfun] = { caption = "That was fun, let's go back to school" }
sfxinfo[sfx_dsleav] = { caption = "Sorry you're leaving, you're going to come back soon right?" }
sfxinfo[sfx_dslike] = { caption = "Like" }
sfxinfo[sfx_dsmath] = { caption = "Let's get ready for math" }
sfxinfo[sfx_dsrecy] = { caption = "You recycled, that's great" }
sfxinfo[sfx_dssadv] = { caption = "Get ready for a Sonic adventure" }
sfxinfo[sfx_dsscho] = { caption = "Let's go back to school" }
sfxinfo[sfx_dsschw] = { caption = "What" }
sfxinfo[sfx_dssmar] = { caption = "*cheering* You're smart" }
-- Mario
sfxinfo[sfx_dsmgib] = { caption = "BLOAHUNFUABUINIJOACNWACAC" }
sfxinfo[sfx_dsmhah] = { caption = "Hahah" }
sfxinfo[sfx_dsmhel] = { caption = "Hello" }
sfxinfo[sfx_dsmher] = { caption = "Here we go" }
sfxinfo[sfx_dsmitm] = { caption = "It's-a me, Mario" }
sfxinfo[sfx_dsmlet] = { caption = "Let's-a go!" }
sfxinfo[sfx_dsmmam] = { caption = "Mamamia" }
sfxinfo[sfx_dsmokl] = { caption = "Okie dokie" }
sfxinfo[sfx_dsmscr] = { caption = "WAAAAAAAOOOOOOH" }
sfxinfo[sfx_dsmwoa] = { caption = "Woah" }
sfxinfo[sfx_dsmwoh] = { caption = "MAMA HOOHAHOO WOWOW" }
sfxinfo[sfx_dsmyah] = { caption = "Yahoo" }
sfxinfo[sfx_dsmyip] = { caption = "Yipee" }
sfxinfo[sfx_dsmbow] = { caption = "So long-a bowser" }
sfxinfo[sfx_dsmcou] = { caption = "*cough*" }
sfxinfo[sfx_dsmdoh] = { caption = "D'oh" }
sfxinfo[sfx_dsmfir] = { caption = "HAHAHAHAHAAAAAH" }
-- half life
sfxinfo[sfx_dshihe] = { caption = "I hear something" }
sfxinfo[sfx_dshlis] = { caption = "Why didn't they listen?" }
sfxinfo[sfx_dshmor] = { caption = "I can't take much more of this" }
sfxinfo[sfx_dshsca] = { caption = "You aren't scared are ya?" }
sfxinfo[sfx_dshser] = { caption = "You can't be serious" }
sfxinfo[sfx_dshtie] = { caption = "Why do we all have to wear these ridiculous ties" }
sfxinfo[sfx_dshway] = { caption = "No, don't go that way" }
sfxinfo[sfx_dshadm] = { caption = "I suspected this would happen, but the administrator just wouldn't listen" }
sfxinfo[sfx_dshah] = { caption = "AH" }
sfxinfo[sfx_dshano] = { caption = "HAHA got another one" }
sfxinfo[sfx_dshcou] = { caption = "*coughing*" }
sfxinfo[sfx_dshcra] = { caption = "Are you crazy?" }
sfxinfo[sfx_dshdie] = { caption = "No I don't want to die!" }
sfxinfo[sfx_dshfoo] = { caption = "Freeman you fool!" }
sfxinfo[sfx_dshhea] = { caption = "Aim for the head if you can find it" }
sfxinfo[sfx_dshher] = { caption = "Did you hear that?" }
sfxinfo[sfx_dshhe2] = { caption = "Did you hear something?" }
sfxinfo[sfx_dshhee] = { caption = "HEEEEEEEEEEEEEEEEY" }
sfxinfo[sfx_dshhel] = { caption = "Hello" }

-- sound lists --
local tauntlist = {
sfx_s2cryl,sfx_sebell,
-- Sonic
sfx_dsshey,sfx_dssits,sfx_dsslow,sfx_dssnot,sfx_dssoil,sfx_dsspre,sfx_dssrat,sfx_dsssav,sfx_dsssay,sfx_dssscr,sfx_dsster,sfx_dsswha,sfx_dsswho,sfx_dssyea,sfx_dssblo,sfx_dsscom,sfx_dssdar,sfx_dssfak,sfx_dssfou,sfx_dssher,
-- Tails
sfx_dsttra,sfx_dstwha,sfx_dstalt,sfx_dstget,sfx_dsthow,sfx_dstjam,sfx_dstknu,sfx_dstnow,sfx_dstscr,sfx_dsttad,
-- Knucks
sfx_dsksho,sfx_dskwha,sfx_dskyou,sfx_dskohn,
-- egg
sfx_dsepho,sfx_dseagh,sfx_dsesil,sfx_dseaha,sfx_dsekee,sfx_dselau,sfx_dseloa,sfx_dsenow,
-- amy
sfx_dsadon,sfx_dsapay,sfx_dsapit,sfx_dsasle,sfx_dsabor,
-- shadow
sfx_dsshve,sfx_dsshwh,sfx_dsshap,sfx_dsshfa,sfx_dsshin,sfx_dsshka,sfx_dsshpa,sfx_dsshst,
-- sonics school house
sfx_dswans,sfx_dsansw,sfx_dsbaby,sfx_dsbuzz,sfx_dsdont,sfx_dselhi,sfx_dsfun,sfx_dsleav,sfx_dslike,sfx_dsmath,sfx_dsrecy,sfx_dssadv,sfx_dsscho,sfx_dsschw,sfx_dssmar,
-- mario
sfx_dsmgib,sfx_dsmhah,sfx_dsmhel,sfx_dsmher,sfx_dsmitm,sfx_dsmlet,sfx_dsmmam,sfx_dsmokl,sfx_dsmscr,sfx_dsmwoa,sfx_dsmwoh,sfx_dsmyah,sfx_dsmyip,sfx_dsmbow,sfx_dsmcou,sfx_dsmdoh,sfx_dsmfir,
-- half life
sfx_dshihe,sfx_dshlis,sfx_dshmor,sfx_dshsca,sfx_dshser,sfx_dshtie,sfx_dshway,sfx_dshadm,sfx_dshah,sfx_dshano,sfx_dshcou,sfx_dshcra,sfx_dshdie,sfx_dshfoo,sfx_dshhea,sfx_dshher,sfx_dshhe2,sfx_dshhee,sfx_dshhel
}

local tauntTime = 30*TICRATE


--== functions ==--
-- do message
local function doPropMessage(propmess, huntmess)
	propmessage[0] = propmess
	propmessage[1] = huntmess
	propmestime = 5*TICRATE
end

-- set spectator
local function setspectator(player)
	player.spectate = true
	P_TeleportMove(player.mo, 30000*FRACUNIT, 30000*FRACUNIT, 0) 
	player.spawndelay = TICRATE
	-- reset values
	R_SetPlayerSkin(player, player.mo.skin)
end



--== Main code ==--

-- sync net values
addHook("NetVars", function(net)
	waitinit = net($)
	waittime = net($)
	matchtime = net($)
	hideseek = net($)
	ringlist = net($)
	tauntTime = net($)
end)



local function doWin(team)
	teamWin = team -- hunters win
	for player in players.iterate do
		if team == player.ctfteam
			S_ChangeMusic("HUNTWIN",false,player)
		else
			S_ChangeMusic("HUNTLOSE",false,player)
		end
	end
	winWait = winTime*TICRATE
end

-- main loop
addHook("ThinkFrame", do
	if gametype == GT_PROPHUNT
		if waittime > 0
			if waittime <= 1 and waitinit != 1
				doPropMessage(propmessages[P_RandomRange(1,#propmessages)],huntmessages[P_RandomRange(1,#huntmessages)])
			end
			waittime = $-1
			if propcount == 0 or huntcount == 0
				waittime = waitinit
			end
		end
		if propmestime > 0
			propmestime = $-1
		end
		-- team count
		propcount = 0
		huntcount = 0
		-- match time
		if waittime <= 0 and teamWin == 0
			if matchtime > 0
				matchtime = $-1
			else -- kill prop hunters
				for player in players.iterate do
					if player.ctfteam == 1
						player.spectate = true
						P_KillMobj(player.mo, nil, mob)
					end
				end
			end
		end
		
		for player in players.iterate do
		
			-- prevent prop swapping team error
			if player.ctfteam == 2 and not player.isprop
				player.ctfteam = 1
				player.mo.color = SKINCOLOR_RED
			end
			if player.ctfteam == 1 and player.isprop
				player.ctfteam = 2
				player.mo.color = SKINCOLOR_BLUE
			end
			
			-- we managed to avoid drowning
			player.powers[pw_underwater] = 30*TICRATE
			
			-- team counts
			if not player.spectate
				if player.ctfteam == 1
					huntcount = $1+1
				elseif player.ctfteam == 2
					propcount = $1+1
				end
			end
			
			
			if ((gametype == GT_PROPHUNT) and not player.spectate)
				player.charflags = SF_NOJUMPSPIN|SF_NOJUMPDAMAGE
				player.charability = CA_NONE
				player.charability2 = CA2_NONE
			end
			-- team stuff
			-- hunters
			if waittime > 0 and player.ctfteam == 1
				player.exiting = 1
				player.rings = defaultrings
				player.awayviewmobj = awaycam
				player.awayviewtics = 1
				player.awayviewaiming = ANGLE_90
				-- switch sub skins
				if (player.cmd.buttons & BT_WEAPONNEXT) and player.canswapskin
					if player.subskinid < #huntskins
						player.subskinid = $1+1
					else
						player.subskinid = 0
					end
					player.canswapskin = false
				end
				if (player.cmd.buttons & BT_WEAPONPREV) and player.canswapskin
					if player.subskinid > 0
						player.subskinid = $1-1
					else
						player.subskinid = #huntskins
					end
					player.canswapskin = false
				end
				
				if not (player.cmd.buttons & BT_WEAPONNEXT) and not (player.cmd.buttons & BT_WEAPONPREV)
					player.canswapskin = true
				end
				--player.health = defaulthealth
				
				if player.locked.x == 0 and player.locked.y == 0 and player.locked.z == 0
					player.locked.x = player.mo.x
					player.locked.y = player.mo.y
					player.locked.z = player.mo.z
				end
				P_TeleportMove(player.mo, player.locked.x, player.locked.y, player.locked.z) 
			else
				-- disable invulnerability
				player.exiting = 0
			end
			-- hunters again but not the waiting
			if player.ctfteam == 1 and #ringlist == 0 and player.rings == 0
				if player.deathtimer > 0
					player.deathtimer = $-1
				else
					player.deathtimer = 1000*TICRATE
					player.spectate = true
					P_KillMobj(player.mo, nil, mob)
				end
			end
			-- player skins
			-- error check, if no prop then go into T pose
			if player.ctfteam == 1 and leveltime > 1 
				if player.subskinid == 0
					if player.huntskin and player.huntskin.valid
						P_RemoveMobj(player.huntskin)
					end
				elseif player.huntskin and player.huntskin.valid
					player.huntskin.angle = player.mo.angle
					P_TeleportMove(player.huntskin, player.mo.x, player.mo.y, player.mo.z)
					-- flash the skin
					if player.powers[pw_flashing] > 0
						if leveltime % 2 == 0
							player.huntskin.flags2 = $ | MF2_DONTDRAW
						else
							player.huntskin.flags2 = $ & ~MF2_DONTDRAW
						end
					else
						player.huntskin.flags2 = $ & ~MF2_DONTDRAW
					end
					if player.subskinid != 0
						player.mo.flags2 = $1 | MF2_DONTDRAW
					end
					if player.huntskin.sprite != huntskins[player.subskinid][2]
						player.huntskin.sprite = huntskins[player.subskinid][2]
					end
				else
					-- animation start
					player.animst = 0
					-- animation end
					player.animen = 0
					-- animation speed
					player.animsp = 1
					-- animation offset (used for the sprite timer)
					player.animoff = 0
					player.shottimer = 0
					player.huntskin = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SUBSKIN)
					player.canswapskin = true
				end
			end
			
			
			-- hide player if spectator
			if player.spectate
				-- always set rings to 0
				player.rings = 0
				if waittime > 0
				-- prevent forced spectate
					player.spectate = false
				end
			end
			
			-- prop think
			if player.bot == 0 and player.isprop and not player.spectate
			
				-- taunting
				-- switch taunt
				if (player.cmd.buttons & BT_WEAPONNEXT) and player.canswaptaunt
					if player.tauntid < #tauntlist
						player.tauntid = $1+1
					else
						player.tauntid = 1
					end
					player.tauntMSGTimer = TICRATE
					player.tauntMSG = sfxinfo[tauntlist[player.tauntid]].caption
					player.canswaptaunt = false
				end
				if (player.cmd.buttons & BT_WEAPONPREV) and player.canswaptaunt
					if player.tauntid > 1
						player.tauntid = $1-1
					else
						player.tauntid = #tauntlist
					end
					player.tauntMSGTimer = TICRATE
					player.tauntMSG = sfxinfo[tauntlist[player.tauntid]].caption
					player.canswaptaunt = false
				end
				
				if not (player.cmd.buttons & BT_WEAPONNEXT) and not (player.cmd.buttons & BT_WEAPONPREV)
					player.canswaptaunt = true
				end
				
				if waittime <= 0
					if player.tauntTimer > 0
						player.tauntTimer = $1-1
					end
					if tauntTime == 0
						player.tauntTimer = TICRATE
					end
					if player.tauntdelay <= 0 or player.tauntTimer == 0
						if ((player.cmd.buttons & BT_ATTACK) or player.tauntTimer == 0) and player.tauntmob == nil
							player.tauntTimer = tauntTime
							player.tauntdelay = tauntTime/2
							if tauntTime > 0
								P_AddPlayerScore(player, 1)
							end
							player.tauntmob = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TAUNT)
							player.tauntmob.playsound = tauntlist[player.tauntid]
							S_StartSound(player.tauntmob,player.tauntmob.playsound)
						end
					else
						player.tauntdelay = $1-1
					end
				end
				
				if player.tauntmob
					P_TeleportMove(player.tauntmob, player.mo.x, player.mo.y, player.mo.z)
					if not S_SoundPlaying(player.tauntmob,player.tauntmob.playsound)
						-- custom sound cheat prevention
						S_StopSound(player.tauntmob)
						P_RemoveMobj(player.tauntmob)
						player.tauntmob = nil
					end
				end
				if player.tauntMSGTimer > 0
					player.tauntMSGTimer = $1-1
				end
				
				-- always set rings to 0
				player.rings = 0
				if player.swapdelay > 0
					player.swapdelay = $-1
				end
				
				-- give 1 frame of level loading for everything to be set
				if leveltime > 1 
					-- error check, if no prop then go into T pose
					if player.prop and player.prop.valid
						player.mo.flags2 = $1 | MF2_DONTDRAW
						player.prop.angle = player.mo.angle
						P_TeleportMove(player.prop, player.mo.x, player.mo.y, player.mo.z+player.propoff)
					else
						player.prop = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_PROP_TPOS)
						player.defence = 0
						player.normalspeed = 22*FRACUNIT
						player.runspeed = 20*FRACUNIT
						player.propoff = 0
					end
				end
			end
			-- spawn location setter
			if player.spawndelay > 0
				player.spawndelay = $1-1
				P_TeleportMove(player.mo, 30000*FRACUNIT, 30000*FRACUNIT, 0) 
			end
			
			
			
			-- hunter skin
			if player.huntskin and player.huntskin.valid and leveltime > 2
				-- 0 = standing
				-- 1 = idle
				-- 2 = walking
				-- 3-4 = running
				-- 6 pain
				-- 8 death 
				-- 13 = jumping
				-- 14 = falling
				player.spriteaction = 0
				if player.mo.sprite2 == 1
					player.spriteaction = 1
				elseif player.mo.sprite2 == 2
					player.spriteaction = 2
				elseif player.mo.sprite2 == 3 or player.mo.sprite2 == 4
					player.spriteaction = 3
				elseif player.mo.sprite2 == 13
					player.spriteaction = 4
				elseif player.mo.sprite2 == 14
					player.spriteaction = 5
				elseif player.mo.sprite2 == 6
					player.spriteaction = 7
				elseif player.mo.sprite2 == 8
					player.spriteaction = 8
				end
				
				-- shooting override
				if (player.cmd.buttons & BT_ATTACK) and player.shottimer <= 0 and player.rings > 0
					player.shottimer = TICRATE/4
				end
				if player.shottimer > 0
					if player.shottimer <= 1 and (player.cmd.buttons & BT_ATTACK)
						player.shottimer = $1+1
					elseif player.shottimer > 1
							player.spriteaction = 6
					end
					
					player.shottimer = $1-1
				end
				
				player.animst = huntskins[player.subskinid][4+player.spriteaction*3]
				player.animen = huntskins[player.subskinid][5+player.spriteaction*3]
				player.animsp = huntskins[player.subskinid][6+player.spriteaction*3]
				
				-- animation logic
				if player.huntskin.frame < player.animst or player.huntskin.frame > player.animen
					player.huntskin.frame = player.animst
					player.animoff = 0
				end
				
				if player.animoff < TICRATE
					player.animoff = $1+player.animsp
				else
					player.animoff = 0
					if player.huntskin.frame < player.animen
						player.huntskin.frame = $1+1
					else
						player.huntskin.frame = player.animst
					end
				end
				
				-- help get sprite2 values
				--print(player.mo.sprite2)
			end
		end
		
		if (waittime <= 0 and teamWin == 0)
			if propcount == 0
				doWin(1) -- hunters win
			end
			if huntcount == 0
				doWin(2) -- props win
			end
		end
		if teamWin != 0
			for player in players.iterate do
				player.exiting = 1
			end
			if winWait > 0
				winWait = $1-1
			elseif (teamWin != 0 and winWait <= 0)
				for player in players.iterate do
					COM_BufInsertText(player,"TIMELIMIT 1")
				end
			end
		end
	end
end)


local function swapProp(player,newProp)
	if not player.spectate
		-- remove current prop
		if player.prop != nil
			P_RemoveMobj(player.prop)
		end
		-- swap prop
		if newProp and newProp.valid
			player.propoff = max(0,min(48*FRACUNIT,newProp.z-player.mo.z))
			player.prop = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z+player.propoff, newProp.type)
			player.defence = (player.prop.height/FRACUNIT)/32
			player.normalspeed = (22-player.defence*2)*FRACUNIT
			player.runspeed = (20-player.defence*2)*FRACUNIT
			-- play sound
			S_StartSound(player.mo,sfx_adderr)
			-- if solid, reset flags
			if (player.prop.flags & MF_SOLID)
				player.prop.flags = MF_NOCLIP
			end
		end
	end
	--P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, newProp.type)
end

addHook("TouchSpecial", function(poked, poker)
	if poker.player.prop and poker.player.prop.valid and not poker.player.spectate
		-- stop prop griefint
		if (poker.player.prop != poked)
			if poked.parent and poked.parent.valid
				if (poked.parent.type == poker.player.prop.type)
					if (abs(poker.player.mo.momx/FRACUNIT) + abs(poker.player.mo.momy/FRACUNIT)) < 2 or (abs(poker.player.mo.x/FRACUNIT-poked.parent.x/FRACUNIT) + abs(poker.player.mo.y/FRACUNIT-poked.parent.y/FRACUNIT)) < 10
						poker.player.mo.momx = $1+(poker.player.mo.x-poked.parent.x)/30
						poker.player.mo.momy = $1+(poker.player.mo.y-poked.parent.y)/30
					end
				end
			else
				if (poked.type == poker.player.prop.type)
					if (abs(poker.player.mo.momx/FRACUNIT) + abs(poker.player.mo.momy/FRACUNIT)) < 2 or (abs(poker.player.mo.x/FRACUNIT-poked.x/FRACUNIT) + abs(poker.player.mo.y/FRACUNIT-poked.y/FRACUNIT)) < 10
						poker.player.mo.momx = $1+(poker.player.mo.x-poked.x)/30
						poker.player.mo.momy = $1+(poker.player.mo.y-poked.y)/30
					end
				end
			end
		end
		-- swap props
		if (poker.player.prop.type != poked.type or poker.player.propoff != max(0,min(48*FRACUNIT,poked.z-poker.player.mo.z))) and poker.player.swapdelay == 0 and (poker.player.cmd.buttons & BT_USE)
			if poked.parent and poked.parent.valid
				swapProp(poker.player, poked.parent)
			else
				swapProp(poker.player, poked)
			end
			-- delay swapping
			poker.player.swapdelay = TICRATE
		end
		
	end
end, MT_NULL)


-- start up values
addHook("PlayerSpawn", function(player)
	-- check game mode is match or hide and seek
	player.isprop = false
	player.spawndelay = 0
	player.tauntdelay = 0
	player.tauntid = 1
	player.tauntmob = nil
	player.tauntMSGTimer = 0
	player.tauntTimer = tauntTime
	player.tauntMSG = ""
	if gametype == GT_PROPHUNT
		if player.ctfteam == 2 -- props
			COM_BufInsertText(player, "chasecam 1")
			player.isprop = true
			player.normalspeed = 22*FRACUNIT
			player.runspeed = 20*FRACUNIT
		elseif player.ctfteam == 1 -- hunters
			player.normalspeed = 32*FRACUNIT
			player.runspeed = 30*FRACUNIT
			player.locked = {}
			player.locked.x = 0
			player.locked.y = 0
			player.locked.z = 0
			player.deathtimer = 5*TICRATE
			player.subskinid = 0
		end
		player.prop = nil
		player.huntskin = nil
		player.swapdelay = TICRATE
		P_RemoveShield(player)
		-- used to determine object height offsets
		player.propoff = 0
		
		-- if match hasn't started, player is in
		if player.ctfteam == 2 -- prop check
			player.canswaptaunt = true
			if waittime > 0
				player.health = 100
				player.defence = 0
				player.spectate = false
			else
			-- if match has started, player is out
				player.health = 0
				player.defence = 0
				setspectator(player)
				player.spawndelay = TICRATE
			end
		end
	end
end)

--[[
match  is  start
           then
		   pla    is    in
		   yer

baba
 is
you
 _|_|
/--''\
||  ||

]]

--  spectate prevention
addHook("MapChange", function()
	if gametype == GT_PROPHUNT
		waittime = waitinit
	end
end)


-- map load
addHook("MapLoad", function()

	if gametype == GT_PROPHUNT
		matchtime = defaultmatchtime
		teamWin = 0
		awaycam = P_SpawnMobj(30000*FRACUNIT, 30000*FRACUNIT, 0, MT_ALTVIEWMAN)
		waittime = waitinit
		ringlist = {}
		-- create prop masks for all things in level
		for prop in mapthings.iterate
			if prop.mobj
				-- count rings
				-- reset is prop for each prop item check
				if (prop.mobj.type == MT_RING)
					table.insert(ringlist, prop)
				end
				
				isprop = true
				
				-- loop through the "don't copy" tables
				for _,i in ipairs(pdontcop)
					if (prop.mobj.flags & i)
						isprop = false
					end
				end
				for _,i in ipairs(pthinddontcop)
					if (prop.mobj.type == i)
						isprop = false
					end
				end
				
				if isprop
					prop.mobj.mask = P_SpawnMobj(prop.mobj.x, prop.mobj.y, prop.mobj.z, MT_PROP)
					prop.mobj.hitbox = P_SpawnMobj(prop.mobj.x, prop.mobj.y, prop.mobj.z, MT_HITBOX)
					prop.mobj.mask.angle = prop.mobj.angle
					prop.mobj.mask.parent = prop.mobj
					
					if prop.mobj.radius > prop.mobj.mask.radius
						prop.mobj.mask.radius = prop.mobj.radius
					end
					if prop.mobj.height > prop.mobj.mask.height
						prop.mobj.mask.height = prop.mobj.height
					end
					
					if prop.mobj.radius > prop.mobj.hitbox.radius
						prop.mobj.hitbox = prop.mobj.radius
					end
					
				end
			end
		end
		-- set the players to not have props on start
		for player in players.iterate
			COM_BufInsertText(player, "allowseenames 0")
			COM_BufInsertText(player,"TIMELIMIT 0")
			COM_BufInsertText(player,"respawnitem 0")
			if player.prop
				player.prop = nil
				player.isprop = false
				player.defence = 0
				player.normalspeed = 22*FRACUNIT
				player.runspeed = 20*FRACUNIT
			end
		end
	end
end)

-- ignore prop
addHook("MobjMoveCollide", function(collider, prop)
	if collider.player.prop and prop == collider.player.prop-- or collider.player.spectate
		return false
	end
end, MT_PLAYER)

-- ignore rings if prop
addHook("TouchSpecial", function(poked, poker)
	if poker.player.prop --or poker.player.spectate
		return true
	else
		-- update ring table
		for _,i in ipairs(ringlist)
			if i.mobj == poked
				table.remove(ringlist,_)
			end
		end
	end
end, MT_NULL)

-- drop prop if dead
addHook("MobjDeath", function(mob)
	if mob.player.prop and mob.player.prop.valid
		P_RemoveMobj(mob.player.prop)
		mob.player.prop = nil
		mob.player.defence = 0
		mob.player.normalspeed = 22*FRACUNIT
		mob.player.runspeed = 20*FRACUNIT
	end
	-- if in match set to spectator
	if waittime <= 0 and mob.player.ctfteam == 2
		mob.player.spectate = true
	end
end, MT_PLAYER)

-- drop if quiting
addHook("PlayerQuit", function(player)
	if player.prop
		P_RemoveMobj(player.prop)
		player.prop = nil
	end
end, MT_PLAYER)



-- only take damage from multiplayer rings
addHook("ShouldDamage", function(mob, inflictor, source)
	if source
		if source.player
			if source.player.spectate
				return false
			end
		end
	end
	
	
	if mob.player.prop
		if inflictor or source
			-- handle health
			if mob.player.defence > 0
				if mob.player.health > 0
					mob.player.pity = 0
					mob.player.rings = 10
					mob.player.losstime = 0
					mob.player.powers[pw_flashing] = 0
					local painsounds = {sfx_hp1, sfx_hp2, sfx_hp3, sfx_hp4, sfx_hp5}
					S_StartSound(mob.player.mo,painsounds[P_RandomRange(1,#painsounds)])
					mob.player.health = $1-(100/mob.player.defence)-1 --gotta detract 1 for rounding offsets
				end
			end
			
			
			if source and source.valid
				if source.type != MT_PLAYER --and isprop
					return false
				end
			else
				return false
			end
			
			if mob.player.prop and mob.player.health <= 0 and mob.player.rings == 0
				P_RemoveMobj(mob.player.prop)
				mob.player.prop = nil
				mob.player.defence = 0
				mob.player.normalspeed = 22*FRACUNIT
				mob.player.runspeed = 20*FRACUNIT
				P_KillMobj(mob.player.mo, nil, source)
			end
			
		end
	end
end, MT_PLAYER)


-- hurt player if they're attacking a prop
addHook("ShouldDamage", function(mob, inflictor, source)
	if source.player and source.player.valid
		if source.player.spectate
			return false
		end
	end
	
	
	-- we're repurposing isprop for a "can hit" variable, start it at false by default and if there's a prop that can hurt the player in the canhurt list set to true
	isprop = false
	-- loop through the "can hurt" table
	for _,i in ipairs(pcanhurt)
		if (inflictor.type == i)
			isprop = true
		end
	end
	-- check that the attacker is a ring and 
	if isprop and source.type == MT_PLAYER
		-- check that player is not invincible
		if source.player.powers[pw_flashing] == 0
			
			-- nearest player prop
			local nearplayerprop
			
			searchBlockmap("objects", function(reference, candidate)
				local maxdist = 10000*FRACUNIT
				local dist = maxdist
				
				-- check that candidate is a player and prop
				if candidate.type == MT_PLAYER and candidate.player.ctfteam == 2 and not candidate.player.spectate
					-- calculate distance
					dist = P_AproxDistance(reference.x-candidate.x,reference.y-candidate.y)
					-- set max dist to current distance so that player that aren't closer don't get counted
					if dist < maxdist
						maxdist = dist
						nearplayerprop = candidate.player
					end
				end
				
				return nil
			end, mob, mob.x - 10000*FRACUNIT, mob.x + 10000*FRACUNIT, mob.y - 10000*FRACUNIT, mob.y + 10000*FRACUNIT)
			
			
			if nearplayerprop
				P_AddPlayerScore(nearplayerprop, 10)
			end
			
			source.player.rings = max(0,$-1-1)
			S_StartSound(source.player.mo,sfx_spkdth)
			
			return false
		end
	end
end, MT_HITBOX)


-- HUD controls


hud.add(function(v, player, camera)
	if gametype == GT_PROPHUNT
		if waittime > 0
			if propcount == 0 or huntcount == 0
				v.drawString(240, 160, "Waiting for players...", V_ALLOWLOWERCASE|V_PERPLAYER, "center")
			else
				v.drawString(240, 160, "Hunt begins in...", V_ALLOWLOWERCASE|V_PERPLAYER, "center")
				v.drawString(240, 168, G_TicsToSeconds(waittime)+1, V_ALLOWLOWERCASE|V_PERPLAYER, "center")
			end
		else
			if player.spectate
				v.drawString(240, 176, "Match in progress...", V_ALLOWLOWERCASE|V_PERPLAYER, "center")
			end
		end
		
		-- time
		hud.disable("time")
		v.draw(16,26,v.cachePatch("STTTIME"), V_PERPLAYER)
		v.drawNum(96,26,G_TicsToMinutes(matchtime+TICRATE), V_PERPLAYER, "right")
		v.draw(96,26,v.cachePatch("STTCOLON"), V_PERPLAYER)
		v.drawNum(120,26,G_TicsToSeconds(matchtime+TICRATE), V_PERPLAYER, "right")
		-- I'm too lazy to program leading zeros
		if (G_TicsToSeconds(matchtime+TICRATE) % 60) < 10
			v.drawNum(112,26,0, V_PERPLAYER, "right")
		end
		
		--if player.ctfteam == 0 -- Spectator HUD.
			--v.fadeScreen(0, 0)
		if player.ctfteam == 1 -- Hunter Team HUD.
			if splitscreen == false
				hud.enable("weaponrings")
				hud.enable("rings")
			else
				hud.disable("weaponrings")
				hud.disable("rings")
			end
			-- draw rings left
			v.draw(16,58,v.cachePatch("STTLEFT"), V_PERPLAYER)
			v.drawNum(120, 58, #ringlist, V_PERPLAYER, "left")
			if waittime > 0
				--v.draw(16,58,v.cachePatch("STTLEFT"), V_PERPLAYER)
				--v.fadeScreen(31, 10)
				-- draw sub skin
				if player.subskinid and player.subskinid > 0
					v.drawString(160, 96,huntskins[player.subskinid][1], V_ALLOWLOWERCASE|V_PERPLAYER, "center")
					v.draw(160,96,v.cachePatch(huntskins[player.subskinid][3]), V_PERPLAYER)
				end
				if propcount == 0 or huntcount == 0
					v.drawString(240, 160, "Waiting for players...", V_ALLOWLOWERCASE|V_PERPLAYER, "center")
				else
					v.drawString(240, 160, "Hunt begins in...", V_ALLOWLOWERCASE|V_PERPLAYER, "center")
					v.drawString(240, 168, G_TicsToSeconds(waittime)+1, V_ALLOWLOWERCASE|V_PERPLAYER, "center")
				end
			--else
				--v.fadeScreen(31, 0)
			end
			if propmestime > 0
				v.drawString(160, 96, propmessage[1], V_ALLOWLOWERCASE|V_PERPLAYER, "center")
			end
		elseif player.ctfteam == 2 -- Prop Team HUD.
			if splitscreen == false
				hud.disable("weaponrings")
				hud.disable("rings")
			else
				hud.enable("weaponrings")
				hud.enable("rings")
			end
			if player.tauntTimer > tauntTime/2
				v.drawString(48, 140, "Taunt Timer", V_ALLOWLOWERCASE|V_PERPLAYER|V_REDMAP, "center")
			else
				v.drawString(48, 140, "Taunt Timer", V_ALLOWLOWERCASE|V_PERPLAYER|V_YELLOWMAP, "center")
			end
			v.drawString(48, 148, G_TicsToSeconds(player.tauntTimer), V_ALLOWLOWERCASE|V_PERPLAYER, "center")
			if player.tauntMSGTimer > 0
				v.drawString(160, 24, "- "+player.tauntMSG+" -", V_ALLOWLOWERCASE|V_PERPLAYER, "center")
			end
			-- health heads up
			if player.health
				v.draw(16,42,v.cachePatch("STTTHEALTH"), V_PERPLAYER)
				v.drawNum(96, 42, max(0,player.health), V_PERPLAYER, "left")
			end
			-- defence
			v.draw(16,58,v.cachePatch("STTDEFENCE"), V_PERPLAYER)
			if player.defence
				v.drawNum(96, 58, max(0,player.defence), V_PERPLAYER, "left")
			else
				v.drawNum(96, 58, 0, V_PERPLAYER, "left")
			end
			
			--v.fadeScreen(0, 0)
			--v.fadeScreen(31, 0)
			if waittime > 0
				v.drawString(100, 72, "CONTROLS", V_YELLOWMAP|V_PERPLAYER, "center")
				v.drawString(100, 80, "Spin - Copy prop", V_ALLOWLOWERCASE|V_PERPLAYER, "center")
			end
			if propmestime > 0
				v.drawString(160, 96, propmessage[0], V_ALLOWLOWERCASE|V_PERPLAYER, "center")
			end
		end
		-- win screen stuff
		if teamWin != 0 and player.ctfteam != 0
			if player.ctfteam == teamWin
				if player.ctfteam == 2
					v.draw(160,100,v.cachePatch("PROPSWIN"), V_PERPLAYER)
				else
					v.draw(160,100,v.cachePatch("HUNTWIN"), V_PERPLAYER)
				end
			else
				if player.ctfteam == 2
					v.draw(160,100,v.cachePatch("PROPSLOSE"), V_PERPLAYER)
				else
					v.draw(160,100,v.cachePatch("HUNTLOSE"), V_PERPLAYER)
				end
			end
		end
	end
end, "game")

-- prevent chat messages from spectators
addHook("PlayerMsg", function(sender, type, target)
	if (sender.ctfteam == 0 or sender.spectate) and gametype == GT_PROPHUNT and waittime <= 0
		if type == 1
			return -- send message if this is being sent to the team
		elseif not target or target.ctfteam != 0 or target.spectate -- ignore message
			CONS_Printf(sender, "Spectature/cross team coomunication has been muted until next match")
			return true
		end
	end
end)


-- Commands

local function setTime(player, arg)
	if arg
		waitinit = arg*TICRATE
		CONS_Printf(player, "waiting time has been set to "+arg+" seconds")
	else
		CONS_Printf(player, "WAITTIME - Seconds until the match starts")
	end
end
local function setMatchTime(player, arg)
	if arg
		defaultmatchtime = arg*60*TICRATE
		matchtime = arg*60*TICRATE
		CONS_Printf(player, "match time has been set to "+G_TicsToMinutes(arg)+" minutes")
	else
		CONS_Printf(player, "MATCHTIME - Seconds until the match starts")
	end
end

local function setTauntTime(player, arg)
	if arg
		tauntTime = arg*TICRATE
		CONS_Printf(player, "taunt time has been set to "+G_TicsToSeconds(arg)+" seconds")
	else
		CONS_Printf(player, "TAUNTTIME - Seconds until the match starts")
	end
end

local function serverMessage(player, arg)
	if arg
		doPropMessage(arg,arg)
	else
		CONS_Printf(player, "WAITTIME - Seconds until the match starts")
	end
end

-- cmd command
-- wait time before being able to move
COM_AddCommand("WAITTIME", setTime, 1)
-- wait time before being able to move
COM_AddCommand("MATCHTIME", setMatchTime, 1)
-- stop players after timer ends
--COM_AddCommand("HIDESEEK", hide, 1)
-- wait time before being able to move
COM_AddCommand("MESSAGE", serverMessage, 1)
-- taunt timer setting
COM_AddCommand("TAUNTTIME", setTauntTime, 1)

